Index: /schedule/Module/calendar.php
===================================================================
--- /schedule/Module/calendar.php	(revision 16119)
+++ /schedule/Module/calendar.php	(revision 16120)
@@ -86,6 +86,4 @@
 							for(var i = 0; i<source.length;i++)
 							{
-								xml.open("GET","http://www.fact-project.org/smartfact/index.php?source="+escape(source[i])+"&time="+year+"-"+month+"-"+day,true);
-								xml.send();
 								
 								if(window.XMLHttpRequest)
@@ -197,56 +195,61 @@
 											//GrapData(Data,Time);
 										}
-										var options = {
-													chart: {
-														renderTo: 'container' /* display to div Graph*/
-														
-													},
-													
-													xAxis: {
-														categories:["12PM","1PM","2PM","3PM","4PM","5PM","6PM","7PM","8PM","9PM","10PM","11PM","12AM","1AM","2AM","3AM","4AM","5AM","6AM","7AM","8AM","9AM","10AM","12PM"]
-													},
-													series:[], /* array of Data  */
-													
-													remove:function()
-													{
-														return false;
-													},
-													
-													 exporting: {							/*--------------------*/
-														buttons: {							/*					  */
-															exportButton: {					/*		Export		  */
-																menuItems: null,			/*		  to		  */
-																onclick: function() {		/*			PNG.file  */
-																	this.exportChart();		/*--------------------*/
-																}
-															}
-														}
-													},
-													plotOptions : {
-													
-													series : {
-															lineWidth: 3,
-													
-														marker : {
-															enabled:false
-														}
-													}
-												}				
-											};
-											var chart = new Highcharts.Chart(options);
-											for(var src=0;src<source.length;src++)
-											{
-												chart.addSeries({name:source[src], data:[]}); // created a series of data and add name of displayed source
-												for(var i=0;i<Data[src].length;i++)
-												{
-													
-													chart.series[src].addPoint({ // series[0] means index of zero in data;
-													x:Time[src][i], // Time
-													y:Data[src][i] // Value
-													})
-													
-												}
-											}
+										
+								
+										
 									}
+								}
+								xml.open("GET","http://www.fact-project.org/smartfact/index.php?source="+escape(source[i])+"&time="+year+"-"+month+"-"+day,true);
+								xml.send();
+							}
+							var options = {
+									chart: {
+										renderTo: 'container' /* display to div Graph*/
+										
+									},
+									
+									xAxis: {
+										categories:["12PM","1PM","2PM","3PM","4PM","5PM","6PM","7PM","8PM","9PM","10PM","11PM","12AM","1AM","2AM","3AM","4AM","5AM","6AM","7AM","8AM","9AM","10AM","12PM"]
+									},
+									series:[], /* array of Data  */
+									
+									remove:function()
+									{
+										return false;
+									},
+									
+									 exporting: {							/*--------------------*/
+										buttons: {							/*					  */
+											exportButton: {					/*		Export		  */
+												menuItems: null,			/*		  to		  */
+												onclick: function() {		/*			PNG.file  */
+													this.exportChart();		/*--------------------*/
+												}
+											}
+										}
+									},
+									plotOptions : {
+									
+									series : {
+											lineWidth: 3,
+									
+										marker : {
+											enabled:false
+										}
+									}
+								}				
+							};
+							var chart = new Highcharts.Chart(options);
+							for(var src=0;src<source.length;src++)
+							{
+								chart.addSeries({name:source[src], data:[]}); // created a series of data and add name of displayed source
+								for(var i=0;i<Data[src].length;i++)
+								{
+									
+									chart.series[src].addPoint({ // series[0] means index of zero in data;
+									x:Time[src][i], // Time
+									y:Data[src][i] // Value
+									})
+									
 								}
 							}