Index: schedule/css/styles.css
===================================================================
--- schedule/css/styles.css	(revision 16411)
+++ schedule/css/styles.css	(revision 16419)
@@ -1,3 +1,22 @@
-
+table.myTable
+{
+	width:100%;
+}
+
+.myTable td
+{
+	border: solid 1px #cecece;
+}
+
+.myTable td.first
+{
+	width:190px;
+}
+
+.myTable td.last
+{
+	width:50px;
+}
+		
 *{
     margin: 0px;
Index: schedule/function/SplitDelete.php
===================================================================
--- schedule/function/SplitDelete.php	(revision 16411)
+++ schedule/function/SplitDelete.php	(revision 16419)
@@ -19,5 +19,16 @@
 					input.setAttribute("required",true)
 				
-		)
+		);
+			td3.appendChild(
+			button=document.createElement('input'),
+			button.setAttribute('type','button'),
+			button.setAttribute('value','[+]'),
+			button.setAttribute('id','btnAddTime'),
+			button.onclick=function(){
+			if($('#Time1').val() != ""){ timeValue = $('#Time1').val();  meas = "disabled"; meas2 = true;    split1();    }else{   alert("please enter value for time to add measurement");   }
+
+				
+			}
+		);
 	var td=document.createElement('td');
 		td.setAttribute("style","border:1px solid white; color:#37DFB1; font-size:14px;text-align:center;");
@@ -66,4 +77,15 @@
 ?>
 			measurementcbo.setAttribute('id','measurement1')
+		);
+				td1.appendChild(
+			button=document.createElement('input'),
+			button.setAttribute('type','button'),
+			button.setAttribute('value','[+]'),
+			button.setAttribute('id','btnAddTime'),
+			button.onclick=function(){
+			if($('#Time1').val() != ""){ timeValue = $('#Time1').val();  meas = "hidden"; meas2 = true;    split1();    }else{   alert("please enter value for time to add measurement");   }
+
+				
+			}
 		);
 	var td2=document.createElement('td');
@@ -101,14 +123,5 @@
 			}
 		);
-			td4.appendChild(
-			button=document.createElement('input'),
-			button.setAttribute('type','button'),
-			button.setAttribute('value','+Measurement'),
-			button.setAttribute('id','btnMeasurement'),
-			button.onclick=function(){
-			
-				if($('#Time1').val() != ""){ timeValue = $('#Time1').val();  meas = "disabled"; meas2 = true;    split1();    }else{   alert("please enter value for time to add measurement");   }				 
-			}
-		);
+		
 		tr.appendChild(td3);
 		tr.appendChild(td1);
@@ -136,5 +149,16 @@
 					input.setAttribute("min","1"),
 					input.setAttribute("required",true)
-		)
+		);
+			td3.appendChild(
+			button=document.createElement('input'),
+			button.setAttribute('type','button'),
+			button.setAttribute('value','[+]'),
+			button.setAttribute('id','btnAddTime'),
+			button.onclick=function(){
+			if($('#Time2').val() != ""){ timeValue = $('#Time2').val();  meas = "disabled"; meas2 = true;    split();    }else{   alert("please enter value for time to add measurement");   }
+
+				
+			}
+		);
 	var td=document.createElement('td');
 		td.setAttribute("style","border:1px solid white; color:#37DFB1; font-size:14px;text-align:center;");
@@ -180,4 +204,15 @@
 ?>
 			measurementcbo.setAttribute('id','measurement2')
+		);
+				td1.appendChild(
+			button=document.createElement('input'),
+			button.setAttribute('type','button'),
+			button.setAttribute('value','[+]'),
+			button.setAttribute('id','btnAddTime'),
+			button.onclick=function(){
+			if($('#Time2').val() != ""){ timeValue = $('#Time2').val();  meas = "hidden"; meas2 = true;    split();    }else{   alert("please enter value for time to add measurement");   }
+
+				
+			}
 		);
 	var td2=document.createElement('td');
@@ -214,17 +249,5 @@
 			}
 		);
-		td4.appendChild(
-			button=document.createElement('input'),
-			button.setAttribute('type','button'),
-			button.setAttribute('value','+Measurement'),
-			button.setAttribute('id','btnMeasurement'),
-			button.onclick=function(){
-			
-			
-			
-					if($('#Time2').val() != ""){ timeValue = $('#Time2').val();  meas = "disabled"; meas2 = true;    split();    }else{   alert("please enter value for time to add measurement");   }		
-				
-			}
-		);
+	
 		tr.appendChild(td3);
 		tr.appendChild(td1);
@@ -251,4 +274,6 @@
 		var td3=document.createElement('td');
 			td3.setAttribute('style','border:1px solid white; color:#37DFB1; font-size:14px; text-align:center;');
+			td3.setAttribute('class','first');
+
 			td3.appendChild(
 				input = document.createElement("input"),
@@ -262,4 +287,16 @@
 						
 			);
+				td3.appendChild(
+			button=document.createElement('input'),
+			button.setAttribute('type','button'),
+			button.setAttribute('value','[+]'),
+			button.setAttribute('id','btnAddTime'),
+			button.setAttribute(meas,meas2),
+			button.onclick=function(){
+			if($('#Time'+cnt).val() != ""){ timeValue = $('#Time'+cnt).val();  meas = "disabled"; meas2 = true;    split1();    }else{   alert("please enter value for time to add measurement");   }
+
+				
+			}
+		);
 			
 		var td=document.createElement('td');
@@ -307,4 +344,17 @@
 			measurementcbo.setAttribute('id','measurement'+cnt)
 			);
+					td1.appendChild(
+			button=document.createElement('input'),
+			button.setAttribute('type','button'),
+			button.setAttribute('value','[+]'),
+			button.setAttribute('id','btnAddTime'),
+			button.onclick=function(){
+			
+			if($('#Time'+cnt).val() != ""){ timeValue = $('#Time'+cnt).val();  meas = "hidden"; meas2 = true;    split1();    }else{   alert("please enter value for time to add measurement");   }
+
+				
+			}
+		);
+				
 		var td2=document.createElement('td');
 			td2.setAttribute("style","border:1px solid white; color:#37DFB1; font-size:14px; text-align:center;");
@@ -338,13 +388,5 @@
 				}
 			);
-			td4.appendChild(
-			button=document.createElement('input'),
-			button.setAttribute('type','button'),
-			button.setAttribute('value','+Measurement'),
-			button.setAttribute('id','btnMeasurement'),
-			button.onclick=function(){
-					if($('#Time'+cnt).val() != ""){ timeValue = $('#Time'+cnt).val();  meas = "disabled"; meas2 = true;    split();    }else{   alert("please enter value for time to add measurement");   }
-			}
-		);
+			
 			tr.appendChild(td3);
 			tr.appendChild(td1);
@@ -375,4 +417,5 @@
 		var td3=document.createElement('td');
 			td3.setAttribute('style','border:1px solid white; color:#37DFB1; font-size:14px; text-align:center;');
+			td3.setAttribute('class','first');
 			td3.appendChild(
 				input = document.createElement("input"),
@@ -385,4 +428,16 @@
 						input.setAttribute("value",timeValue)
 			);
+				td3.appendChild(
+			button=document.createElement('input'),
+			button.setAttribute('type','button'),
+			button.setAttribute('value','[+]'),
+			button.setAttribute('id','btnAddTime'),
+			button.setAttribute(meas,meas2),
+			button.onclick=function(){
+			if($('#Time'+cnt).val() != ""){ timeValue = $('#Time'+cnt).val();  meas = "disabled"; meas2 = true;    split1();    }else{   alert("please enter value for time to add measurement");   }
+
+				
+			}
+		);
 			
 		var td=document.createElement('td');
@@ -411,4 +466,5 @@
 		var td1=document.createElement('td');
 			td1.setAttribute("style","border:1px solid white; color:#37DFB1; font-size:14px;text-align:center;");
+			
 			td1.appendChild(
 				measurementcbo= document.createElement('select'),
@@ -430,4 +486,17 @@
 			measurementcbo.setAttribute('id','measurement'+cnt)
 			);
+				td1.appendChild(
+			button=document.createElement('input'),
+			button.setAttribute('type','button'),
+			button.setAttribute('value','[+]'),
+			button.setAttribute('id','btnAddTime'),
+			button.onclick=function(){
+		
+			if($('#Time'+cnt).val() != ""){ timeValue = $('#Time'+cnt).val();  meas = "hidden"; meas2 = true;    split1();    }else{   alert("please enter value for time to add measurement");   }
+
+				
+			}
+		);
+		
 		var td2=document.createElement('td');
 			td2.setAttribute("style","border:1px solid white; color:#37DFB1; font-size:14px; text-align:center;");
@@ -460,15 +529,5 @@
 					cnt--;
 			});
-			td4.appendChild(
-			button=document.createElement('input'),
-			button.setAttribute('type','button'),
-			button.setAttribute('value','+Measurement'),
-			button.setAttribute('id','btnMeasurement'),
-			button.onclick=function(){
-			if($('#Time'+cnt).val() != ""){ timeValue = $('#Time'+cnt).val();  meas = "disabled"; meas2 = true;    split1();    }else{   alert("please enter value for time to add measurement");   }
-
-				
-			}
-		);
+		
 			tr.appendChild(td3);
 			tr.appendChild(td1);