Index: trunk/FACT++/configure
===================================================================
--- trunk/FACT++/configure	(revision 15492)
+++ trunk/FACT++/configure	(revision 16957)
@@ -628,6 +628,4 @@
 HAS_DBUS_FALSE
 HAS_DBUS_TRUE
-HAS_SOPRANO_FALSE
-HAS_SOPRANO_TRUE
 HAS_NOVA_FALSE
 HAS_NOVA_TRUE
@@ -982,7 +980,4 @@
 with_qwt_include
 with_qwt_libdir
-with_soprano
-with_soprano_include
-with_soprano_libdir
 with_root
 with_rootsys
@@ -1757,8 +1752,4 @@
   --with-qwt-libdir=DIR        specify exact library dir for qwt library (e.g. libqwt-qt4)
   --without-qwt        disables qwt usage completely
-  --with-soprano=DIR	root directory of soprano installation
-  --with-soprano-include=DIR        specify exact include dir for soprano headers (e.g. Soprano/Soprano)
-  --with-soprano-libdir=DIR        specify exact library dir for soprano library (e.g. libsoprano)
-  --without-soprano        disables soprano usage completely
   --without-root          Disable root, i.e. disable gui support.
   --with-rootsys          path to the ROOT executables or top ROOT
@@ -4933,5 +4924,4 @@
 # gl
 # QtCore
-# soprano
 # cfitsio
 
@@ -23980,5 +23970,5 @@
 
 		cat > conftest.$ac_ext <<EOF
-#line 23982 "configure"
+#line 23972 "configure"
 #include "confdefs.h"
 #include <qglobal.h>
@@ -24416,139 +24406,4 @@
 
 
-
-
-# Check whether --with-soprano was given.
-if test "${with_soprano+set}" = set; then :
-  withval=$with_soprano; with_soprano=$withval
-if test "${with_soprano}" != yes; then
-	soprano_include="$withval/include"
-	soprano_libdir="$withval/lib"
-fi
-
-fi
-
-
-
-# Check whether --with-soprano-include was given.
-if test "${with_soprano_include+set}" = set; then :
-  withval=$with_soprano_include; soprano_include="$withval"
-fi
-
-
-
-# Check whether --with-soprano-libdir was given.
-if test "${with_soprano_libdir+set}" = set; then :
-  withval=$with_soprano_libdir; soprano_libdir="$withval"
-fi
-
-
-if test "${with_soprano}" != no ; then
-	OLD_LIBS=$LIBS
-	OLD_LDFLAGS=$LDFLAGS
-	OLD_CFLAGS=$CFLAGS
-	OLD_CPPFLAGS=$CPPFLAGS
-
-	if test "${soprano_libdir}" ; then
-		LDFLAGS="$LDFLAGS -L${soprano_libdir}"
-	fi
-	if test "${soprano_include}" ; then
-		CPPFLAGS="$CPPFLAGS -I${soprano_include}"
-		CFLAGS="$CFLAGS -I${soprano_include}"
-	fi
-
-        no_good=no
-
-	ac_fn_cxx_check_header_mongrel "$LINENO" "Soprano/Soprano" "ac_cv_header_Soprano_Soprano" "$ac_includes_default"
-if test "x$ac_cv_header_Soprano_Soprano" = xyes; then :
-
-else
-  no_good=yes
-fi
-
-
-
-        ac_ext=cpp
-ac_cpp='$CXXCPP $CPPFLAGS'
-ac_compile='$CXX -c $CXXFLAGS $CPPFLAGS conftest.$ac_ext >&5'
-ac_link='$CXX -o conftest$ac_exeext $CXXFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
-ac_compiler_gnu=$ac_cv_cxx_compiler_gnu
-
-
-
-
-
-
-
-   { $as_echo "$as_me:${as_lineno-$LINENO}: checking for Soprano::PluginManager::instance in -lsoprano" >&5
-$as_echo_n "checking for Soprano::PluginManager::instance in -lsoprano... " >&6; }
-if ${ac_cv_lib_soprano_Soprano__PluginManager__instance+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-
-   	ac_check_lib_save_LIBS=$LIBS
-   	LIBS="-lsoprano  $LIBS"
-   	cat confdefs.h - <<_ACEOF >conftest.$ac_ext
-/* end confdefs.h.  */
-#include <Soprano/Soprano>
-int
-main ()
-{
-Soprano::PluginManager::instance
-  ;
-  return 0;
-}
-_ACEOF
-if ac_fn_cxx_try_link "$LINENO"; then :
-  ac_cv_lib_soprano_Soprano__PluginManager__instance=yes
-else
-  ac_cv_lib_soprano_Soprano__PluginManager__instance=no
-fi
-rm -f core conftest.err conftest.$ac_objext \
-    conftest$ac_exeext conftest.$ac_ext
-   	LIBS=$ac_check_lib_save_LIBS
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_soprano_Soprano__PluginManager__instance" >&5
-$as_echo "$ac_cv_lib_soprano_Soprano__PluginManager__instance" >&6; }
-   	if test $ac_cv_lib_soprano_Soprano__PluginManager__instance = yes; then :
-
-
-           		cat >>confdefs.h <<_ACEOF
-#define HAVE_LIBSOPRANO 1
-_ACEOF
-
-   			LIBS="-lsoprano $LIBS"
-
-
-else
-  no_good=yes
-fi
-
-
-
-        ac_ext=cpp
-ac_cpp='$CXXCPP $CPPFLAGS'
-ac_compile='$CXX -c $CXXFLAGS $CPPFLAGS conftest.$ac_ext >&5'
-ac_link='$CXX -o conftest$ac_exeext $CXXFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
-ac_compiler_gnu=$ac_cv_cxx_compiler_gnu
-
-
-	if test "$no_good" = yes; then
-		HAVE_SOPRANO=no
-
-		LIBS=$OLD_LIBS
-		LDFLAGS=$OLD_LDFLAGS
-		CPPFLAGS=$OLD_CPPFLAGS
-		CFLAGS=$OLD_CFLAGS
-	else
-		HAVE_SOPRANO=yes
-
-		$as_echo "#define HAVE_PKG_soprano 1" >>confdefs.h
-
-	fi
-
-fi
-
-
-
 ######################################################################
 # ROOT SUPPORT
@@ -25227,12 +25082,4 @@
   HAS_NOVA_TRUE='#'
   HAS_NOVA_FALSE=
-fi
-
- if test "$HAVE_SOPRANO" = yes; then
-  HAS_SOPRANO_TRUE=
-  HAS_SOPRANO_FALSE='#'
-else
-  HAS_SOPRANO_TRUE='#'
-  HAS_SOPRANO_FALSE=
 fi
 
@@ -25628,8 +25475,4 @@
 if test -z "${HAS_NOVA_TRUE}" && test -z "${HAS_NOVA_FALSE}"; then
   as_fn_error $? "conditional \"HAS_NOVA\" was never defined.
-Usually this means the macro was only invoked conditionally." "$LINENO" 5
-fi
-if test -z "${HAS_SOPRANO_TRUE}" && test -z "${HAS_SOPRANO_FALSE}"; then
-  as_fn_error $? "conditional \"HAS_SOPRANO\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
@@ -28142,6 +27985,4 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}:  Qwt                    / qwt_plot.h         found: $HAVE_QWT" >&5
 $as_echo "$as_me:  Qwt                    / qwt_plot.h         found: $HAVE_QWT" >&6;}
-{ $as_echo "$as_me:${as_lineno-$LINENO}:  Soprano                / Soprano/Soprano    found: $HAVE_SOPRANO" >&5
-$as_echo "$as_me:  Soprano                / Soprano/Soprano    found: $HAVE_SOPRANO" >&6;}
 { $as_echo "$as_me:${as_lineno-$LINENO}:  cfitsio                / 'fitsio.h'         found: $HAVE_CFITSIO" >&5
 $as_echo "$as_me:  cfitsio                / 'fitsio.h'         found: $HAVE_CFITSIO" >&6;}
@@ -28427,9 +28268,4 @@
 $as_echo "$as_me: WARNING:  DBus libraries missing - skypeclient will not be compiled!" >&2;}
 fi
-if test -z "$HAS_SOPRANO_TRUE"; then :
-  else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Soprano libraries missing - tngweather will not be compiled!" >&5
-$as_echo "$as_me: WARNING:  Soprano libraries missing - tngweather will not be compiled!" >&2;}
-fi
 { $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
 $as_echo "$as_me: " >&6;}